<?php if ( !defined( 'ABSPATH' ) ) exit;//PHPの宣言と直接アクセスの拒否
/* セクションID haumenu_define_section_id_05_blockoption() */
/* タブのスラグ haumenu_define_tab_slug_05_blockoption() */
/* $option_name 設定名 haumenu_define_option_name_05_blockoption() */
/* get_option GetOP05_blockoption() */

/***** 親設定の有効／無効に合わせて子設定の表示方法を変更する *****/
/* 関数名・設定名は画面ごとに変えること（関数重複を防ぐ） */
/* add_action('admin_notices', 'current_pagehook');を追加してページ名を取得し、$page_fooksuffixの値を変える */
/* 連動マップ（ID => セレクター）の項目を編集する */

function haup_child_setting_view_control_05_blockoption( $hook_suffix ) {
	//ページフックにより出力を判断
	$page_fooksuffix = 'ha-utilitiy_page_haumenu_page_blockoption';

	if ( $page_fooksuffix !== $hook_suffix ) {
		return;
	}

	//メインスクリプトのハンドル
	$handle = 'haup-child-setting-control-js';

	// メインスクリプトが登録されていなければ終了(スクリプトの読み込みはmain-menu.phpで記述)
	if ( ! wp_script_is( $handle, 'registered' ) ) {
		return;
	}

	//設定名
	$set_name = haumenu_define_option_name_05_blockoption();

	// 連動マップ（ID => セレクター）
	// 1つのIDに対して複数のCSSクラスを指定する（1つなら1行）
	$dependency_map = array(
		//$set_name . 'use-resizing-latest-posts-block-image' => array(
			//'.latest-posts-block-image-height-wrapper', // 最近の投稿ブロックの画像の高さ
		//),

	);

	$inner_js = "";
	foreach ( $dependency_map as $id => $selectors ) {
		foreach ( (array) $selectors as $selector ) {
			// translators: %s stands for the CSS Class & ID.
			$inner_js .= sprintf(
				"haup_apply_dependency('%s', '%s');\n",
				esc_js( $id ),
				esc_js( $selector )
			);
		}
	}

	if ( $inner_js ) {
		$js_code = "if (window.haup_apply_dependency) {\n" . $inner_js . "}";
		// 第3引数を 'after' にすることで、本体JSの直後に出力
		wp_add_inline_script( $handle, $js_code, 'after' );
	}
}
add_action( 'admin_enqueue_scripts', 'haup_child_setting_view_control_05_blockoption', 20 );

/*** コピーボタン機能を使うかどうか ***/
/* 項目の追加とデータの更新 */
function haumenu_init_field_autoadd_codeblock_copy_button(){
//項目の追加
	add_settings_field(
		'autoadd-codeblock-copy-button', // 設定名
		__('Show copy button in code block','hima-art-utility'), // 設定タイトル
		'haumenu_autoadd_codeblock_copy_button', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_05_blockoption(), //表示させるタブのスラグ
		haumenu_define_section_id_05_blockoption(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-separate' )
	);

}
add_action( 'admin_init', 'haumenu_init_field_autoadd_codeblock_copy_button' );

/* 入力フォーム */
function haumenu_autoadd_codeblock_copy_button() {
	$set_name = haumenu_define_option_name_05_blockoption(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'autoadd-codeblock-copy-button'; //個別配列名

	//テーブルに値がなかった場合の措置（PHP8.x以降への対応）
	if(isset($options[$option_name])){
		$checked = $options[$option_name];
	}else{
		$checked = '';
	}
?>
<label>
	<input type="checkbox" id="<?php echo esc_html($set_name . $option_name ); ?>" name="<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>" class="wppd-ui-toggle" <?php checked( $checked , 1 ); ?> value="1">
	<p><?php esc_html_e('When enabled, automatically displays the copy button when the mouse is over the code block on the display screen','hima-art-utility'); ?></p>
</label>
<?php
}

/*** コピーボタンの文字色 ***/
/* 項目の追加とデータの更新 */
function haumenu_init_field_codeblock_copy_button_text_color(){
//項目の追加
	add_settings_field(
		'codeblock-copy-button-text-color', // 設定名
		__('text color of message','hima-art-utility'), // 設定タイトル
		'haumenu_codeblock_copy_button_text_color', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_05_blockoption(), //表示させるタブのスラグ
		haumenu_define_section_id_05_blockoption(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-separate' )
	);

}
add_action( 'admin_init', 'haumenu_init_field_codeblock_copy_button_text_color' );

/* 入力項目 */
function haumenu_codeblock_copy_button_text_color() {
	$set_name = haumenu_define_option_name_05_blockoption(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'codeblock-copy-button-text-color'; //個別配列名
?>
<label>
	<input name="<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>" class="color-picker-hex" type="text" id="<?php echo esc_html($set_name . $option_name); ?>" maxlength="7" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>" placeholder="#ffffff" data-default-color="#ffffff">
</label>
	<p><?php esc_html_e('Specifies the text color of the message displayed when the mouse is over (default is #ffffff)','hima-art-utility'); ?></p>
<?php
}

/*** コピーボタンの背景色 ***/
/* 項目の追加とデータの更新 */
function haumenu_init_field_codeblock_copy_button_bg_color(){
//項目の追加
	add_settings_field(
		'codeblock-copy-button-bg-color', // 設定名
		__('message background color','hima-art-utility'), // 設定タイトル
		'haumenu_codeblock_copy_button_bg_color', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_05_blockoption(), //表示させるタブのスラグ
		haumenu_define_section_id_05_blockoption(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-separate' )
	);

}
add_action( 'admin_init', 'haumenu_init_field_codeblock_copy_button_bg_color' );

/* 入力項目 */
function haumenu_codeblock_copy_button_bg_color() {
	$set_name = haumenu_define_option_name_05_blockoption(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'codeblock-copy-button-bg-color'; //個別配列名
?>
<label>
	<input name="<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>" class="color-picker-hex" type="text" id="<?php echo esc_html($set_name . $option_name); ?>" maxlength="7" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>" placeholder="#333" data-default-color="#333">
</label>
<p><?php esc_html_e('Specifies the background color of the message displayed on mouseover (default is #333)','hima-art-utility'); ?></p>
<?php
}

/*** コピーボタンの枠線色 ***/
/* 項目の追加とデータの更新 */
function haumenu_init_field_codeblock_copy_button_border_color(){
//項目の追加
	add_settings_field(
		'codeblock-copy-button-border-color', // 設定名
		__('message border color','hima-art-utility'), // 設定タイトル
		'haumenu_codeblock_copy_button_border_color', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_05_blockoption(), //表示させるタブのスラグ
		haumenu_define_section_id_05_blockoption(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-separate' )
	);

}
add_action( 'admin_init', 'haumenu_init_field_codeblock_copy_button_border_color' );

/* 入力項目 */
function haumenu_codeblock_copy_button_border_color() {
	$set_name = haumenu_define_option_name_05_blockoption(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'codeblock-copy-button-border-color'; //個別配列名
?>
<label>
	<input name="<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>" class="color-picker-hex" type="text" id="<?php echo esc_html($set_name . $option_name); ?>" maxlength="7" value="<?php echo esc_attr($options[ $option_name ] ?? ''); ?>" placeholder="#111" data-default-color="#111">
</label>
<p><?php esc_html_e('Specifies the border color of the message displayed on mouseover (default is #111)','hima-art-utility'); ?></p>
<?php
}

/*** コピーボタン機能を停止できるようにするか ***/
/* 項目の追加とデータの更新 */
function haumenu_init_field_disable_spec_codeblock_copy_button(){
//項目の追加
	add_settings_field(
		'disable-spec-codeblock-copy-button', // 設定名
		'', // 設定タイトル
		'haumenu_disable_spec_codeblock_copy_button', // 設定項目のHTMLを出力する関数名
		haumenu_define_tab_slug_05_blockoption(), //表示させるタブのスラグ
		haumenu_define_section_id_05_blockoption(),// $section 表示させるセクションのID
		array( 'class' => 'ha-settings-separate' )
	);

}
add_action( 'admin_init', 'haumenu_init_field_disable_spec_codeblock_copy_button' );

/* 入力フォーム */
function haumenu_disable_spec_codeblock_copy_button() {
	$set_name = haumenu_define_option_name_05_blockoption(); //  $option_name 設定名
	$options = get_option($set_name);
	$option_name = 'disable-spec-codeblock-copy-button'; //個別配列名

	//テーブルに値がなかった場合の措置（PHP8.x以降への対応）
	if(isset($options[$option_name])){
		$checked = $options[$option_name];
	}else{
		$checked = '';
	}
?>
<label>
	<input type="checkbox" id="<?php echo esc_html($set_name . $option_name ); ?>" name="<?php echo esc_html($set_name . '[' .$option_name. ']'); ?>" class="wppd-ui-toggle" <?php checked( $checked , 1 ); ?> value="1">
	<p><?php esc_html_e('In a specific code block disable the copy button functionality','hima-art-utility'); ?></p>
</label>
<p><?php esc_html_e('When enabled, selecting "Stop Copy Function" in the style settings that can be selected when inserting a code block will stop the copy function for that code block even if "Show copy button in code block" is enabled. I can.','hima-art-utility'); ?></p>
<?php
}